USES Dos;
CONST
  ScrLINES = 25;
  MaxLINES = 200;
  MaxVTop  = MaxLINES-ScrLINES;

TYPE
 Direction = (Up, Down, NONE);

VAR
  CharHeightABS : Byte ABSOLUTE $0040:$0085;
  CharHeight    : Byte;
  PALPanning    : ShortInt;
  OldInt09      : PROCEDURE;
  VideoTOP      : Integer;
  WayToGo       : Direction;
  Escaped       : Boolean;


PROCEDURE WaitVRetrace; ASSEMBLER;
ASM
        MOV     DX, $03DA
        MOV     AH, 8
 @W1:   IN      AL, DX
        TEST    AL, AH
        JNZ     @W1
 @W2:   IN      AL, DX
        TEST    AL, AH
        JZ      @W2
END;

PROCEDURE SetPALPanning(Value:Byte); ASSEMBLER;
ASM
        CLI
@Wait:  MOV     DX, $3DA
        IN      AX, DX
        AND     AX, 8
        JZ      @Wait
        MOV     AL, $08
        MOV     AH, Value
        MOV     DX, $3D4
        OUT     DX, AX
        STI
END;

PROCEDURE SetVideoOffset(VideoOffset:Word); ASSEMBLER;
ASM
        MOV     DX, $03DA
        MOV     AH, 8
 @W1:   IN      AL, DX
        TEST    AL, AH
        JNZ     @W1          { Wait begin of VRetrace }

        CLI
        MOV     AX, VideoOffset
        MOV     AL, $0C
        MOV     DX, $3D4
        OUT     DX, AX
        MOV     AX, VideoOffset
        MOV     CL, 8
        SHL     AX, CL
        MOV     AL, $0D
        MOV     DX, $3D4
        OUT     DX, AX
        STI
END;

{$F+}
PROCEDURE NewInt09_; INTERRUPT; ASSEMBLER;
ASM
  IN    AL, 60h
  MOV   WayToGO, NONE
  CMP   AL, 128
  JL    @Quit

  CMP   AL, 1 {ESCAPE}
  JNE   @TestUP
  MOV   Escaped, TRUE

@TestUP:
  CMP   AL, 72 {UP}
  JNE   @TestDOWN
  MOV   WayToGo, UP

@TestDOWN:
  CMP   AL, 80 {DOWN}
  JNE   @Quit
  MOV   WayToGo, DOWN

@Quit:
  MOV   AL, 20h
  OUT   20h, AL { Send EOI }
END;
{$F-}


PROCEDURE Update;
VAR Offset:Word;
BEGIN
  Offset := (Pred(VideoTOP) * 160) DIV 2;
  SetVideoOffset(Offset);
  SetPALPanning(PALPanning);
END;


{ --------------- }
BEGIN
  Writeln('Use UP and DOWN keys to scroll the screen.');
  Writeln('Press ESC to exit.');
  PALPanning  := 0;
  WayToGo     := NONE;
  Escaped     := False;
  VideoTOP    := 1;
  CharHeight  := CharHeightABS-1;

  GetIntVec($9,@OldInt09);
  SetIntVec($9,Addr(NewInt09_));
  REPEAT
    WaitVRetrace;
    CASE WayToGo OF
      UP: BEGIN
            IF PALPanning <> 0
              THEN Dec(PALPanning)
              ELSE IF VideoTOP <> 1
                   THEN BEGIN
                         PALPanning := CharHeight;
                         Dec(VideoTOP);
                         Update;
                       END;
          END;
    DOWN: BEGIN
           IF PALPanning <> CharHeight
             THEN Inc(PALPanning)
             ELSE IF (VideoTOP <> MaxVTop)
             THEN BEGIN
                   PALPanning := 0;
                   Inc(VideoTOP);
                   Update;
                 END;
          END;
     END; {CASE}
     IF WayToGo <> NONE THEN SetPALPanning(PALPanning);
  UNTIL Escaped;
  SetVideoOffset(0);
  SetPalPanning(0);
  SetIntVec($9,@OldInt09);
  Mem[Seg0040:$17] := $00; { Reset KBD Info }
END.